//*****************************************************************************************************
//  1. t@C
//		MenuCommon.cpp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		ڑn}E@\n}E@\}̑상j[̋ʐeNX
//----------------------------------------------------------------------------------------------------
//  3. l
//*****************************************************************************************************

#include "stdafx.h"
#include "Schematic.h"
#include "MenuCommon.h"
#include "MenuButton.h"

#define HALF_TRANSPARENT	150

// CMenuCommon _CAO

IMPLEMENT_DYNAMIC(CMenuCommon, CDialogEx)

//*****************************************************************************************************
//  1. ֐
//		CMenuCommon::CMenuCommon
//----------------------------------------------------------------------------------------------------
//  2. @\
//		RXgN^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT	nID			[I] \[XID
//		CWnd*	pParent		[I] eEBhE
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
CMenuCommon::CMenuCommon(UINT nID, CWnd* pParent)
	: CDialogEx(nID, pParent)
{
	m_bSlowSpeed = FALSE;
}

void CMenuCommon::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CMenuCommon, CDialogEx)
	ON_BN_CLICKED(IDC_BUTTON_ZOOM_IN, &CMenuCommon::OnBnClickedButtonZoomIn)
	ON_BN_CLICKED(IDC_BUTTON_ZOOM_OUT, &CMenuCommon::OnBnClickedButtonZoomOut)
	ON_BN_CLICKED(IDC_BUTTON_SIZE_RESET, &CMenuCommon::OnBnClickedButtonSizeReset)
	ON_BN_CLICKED(IDC_BUTTON_PRINT, &CMenuCommon::OnBnClickedButtonPrint)
	ON_BN_CLICKED(IDC_BUTTON_EXIT, &CMenuCommon::OnBnClickedButtonExit)
	ON_BN_CLICKED(IDC_BUTTON_PAUSE, &CMenuCommon::OnBnClickedButtonPause)
	ON_BN_CLICKED(IDC_BUTTON_SLOW, &CMenuCommon::OnBnClickedButtonSlow)
	ON_BN_CLICKED(IDC_BUTTON_NORMAL, &CMenuCommon::OnBnClickedButtonNormal)
	ON_WM_ACTIVATE()
	ON_WM_NCLBUTTONDBLCLK()
END_MESSAGE_MAP()


// CMenuCommon bZ[W nh

//*****************************************************************************************************
//  1. ֐
//		CMenuCommon::OnInitDialog
//----------------------------------------------------------------------------------------------------
//  2. @\
//		_CAO
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL	TRUE
//*****************************************************************************************************
BOOL CMenuCommon::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	EnableSpeedButton(FALSE);

	// eEBhẺE[ɕ\
	if (m_pParentWnd != NULL) {
		CRect rectWindow;
		CRect rectParent;
		GetWindowRect(rectWindow);
		m_pParentWnd->GetWindowRect(rectParent);
		SetWindowPos(NULL, rectParent.right - rectWindow.Width() - 5, rectWindow.top + 5, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
	}

	// _CAÕTCYۑ
	GetClientRect(m_rectClient);

	// I{^ɃtH[JXݒ
	GetDlgItem(IDC_BUTTON_EXIT)->SetFocus();

	return FALSE;
}

//*****************************************************************************************************
//  1. ֐
//		CMenuCommon::OnBnClickedButtonZoomIn
//----------------------------------------------------------------------------------------------------
//  2. @\
//		ugv{^NbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CMenuCommon::OnBnClickedButtonZoomIn()
{
	GetDlgItem(IDC_BUTTON_ZOOM_IN)->EnableWindow((BOOL)SendMessageParent(WM_USER_ZOOM_IN));
	GetDlgItem(IDC_BUTTON_ZOOM_OUT)->EnableWindow(TRUE);
}

//*****************************************************************************************************
//  1. ֐
//		CMenuCommon::OnBnClickedButtonZoomOut
//----------------------------------------------------------------------------------------------------
//  2. @\
//		ukv{^NbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CMenuCommon::OnBnClickedButtonZoomOut()
{
	GetDlgItem(IDC_BUTTON_ZOOM_OUT)->EnableWindow((BOOL)SendMessageParent(WM_USER_ZOOM_OUT));
	GetDlgItem(IDC_BUTTON_ZOOM_IN)->EnableWindow(TRUE);
}

//*****************************************************************************************************
//  1. ֐
//		CMenuCommon::OnBnClickedButtonSizeReset
//----------------------------------------------------------------------------------------------------
//  2. @\
//		uTCYZbgv{^NbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CMenuCommon::OnBnClickedButtonSizeReset()
{
	SendMessageParent(WM_USER_SIZE_RESET);

	GetDlgItem(IDC_BUTTON_ZOOM_IN)->EnableWindow(TRUE);
	GetDlgItem(IDC_BUTTON_ZOOM_OUT)->EnableWindow(TRUE);
}

//*****************************************************************************************************
//  1. ֐
//		CMenuCommon::OnBnClickedButtonPrint
//----------------------------------------------------------------------------------------------------
//  2. @\
//		uv{^NbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CMenuCommon::OnBnClickedButtonPrint()
{
	SendMessageParent(WM_USER_PRINT);
}

//*****************************************************************************************************
//  1. ֐
//		CMenuCommon::OnBnClickedButtonExit
//----------------------------------------------------------------------------------------------------
//  2. @\
//		uIv{^NbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CMenuCommon::OnBnClickedButtonExit()
{
	SendMessageParent(WM_USER_EXIT);
}

//*****************************************************************************************************
//  1. ֐
//		CMenuCommon::OnCancel
//----------------------------------------------------------------------------------------------------
//  2. @\
//		LZ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CMenuCommon::OnCancel()
{
	// ESCL[ŕ̂h
}

//*****************************************************************************************************
//  1. ֐
//		CMenuCommon::SendAction
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Flash֓wM
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		int			nActionNo			[I] ANVԍ
//		CUIntArray	*pParamArray		[I] tp[^̔z
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CMenuCommon::SendAction(int nActionNo, CUIntArray *pParamArray)
{
	SendMessageParent(WM_USER_ACTION, nActionNo, (LPARAM)pParamArray);
}

//*****************************************************************************************************
//  1. ֐
//		CMenuCommon::SendMessageParent
//----------------------------------------------------------------------------------------------------
//  2. @\
//		eEBhEփbZ[WM
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT	nMessage		[I] bZ[Wԍ
//		WPARAM	wParam			[I] ʒmp[^
//		LPARAM	lParam			[I] ʒmp[^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		LRESULT		bZ[W
//*****************************************************************************************************
LRESULT CMenuCommon::SendMessageParent(UINT nMessage, WPARAM wParam, LPARAM lParam)
{
	return m_pParentWnd->SendMessage(nMessage, wParam, lParam);
}

//*****************************************************************************************************
//  1. ֐
//		CMenuCommon::OnNcLButtonDblClk
//----------------------------------------------------------------------------------------------------
//  2. @\
//		^Cg̃_uNbNŃ^Cĝ݂ɏk
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT	nHitTest		[I] qbgeXgR[h
//		CPoint	point			[I] J[\ʒu
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CMenuCommon::OnNcLButtonDblClk(UINT nHitTest, CPoint point)
{
	if (nHitTest == HTCAPTION) {
		CRect rectClinet;
		GetClientRect(rectClinet);
		rectClinet.bottom = (rectClinet.bottom == 0) ? m_rectClient.bottom : 0;
		CalcWindowRect(rectClinet, FALSE);
		SetWindowPos(NULL, 0, 0, rectClinet.Width(), rectClinet.Height(), SWP_NOMOVE | SWP_NOZORDER);
	}

	CDialogEx::OnNcLButtonDblClk(nHitTest, point);
}

//*****************************************************************************************************
//  1. ֐
//		CMenuCommon::OnBnClickedButtonPause
//----------------------------------------------------------------------------------------------------
//  2. @\
//		uꎞ~v{^NbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CMenuCommon::OnBnClickedButtonPause()
{
	CWnd *pWnd = GetDlgItem(IDC_BUTTON_PAUSE);

	if (pWnd->SendMessage(BM_GETCHECK) == BST_CHECKED) {
		pWnd->SetWindowText("~");
		SendMessageParent(WM_USER_PAUSE, 1);
		EnableButton(IDC_BUTTON_SLOW, FALSE);
		EnableButton(IDC_BUTTON_NORMAL, FALSE);
	} else {
		pWnd->SetWindowText("ꎞ~");
		SendMessageParent(WM_USER_PAUSE, 0);
		EnableButton(IDC_BUTTON_SLOW, TRUE);
		EnableButton(IDC_BUTTON_NORMAL, m_bSlowSpeed);
	}
}

//*****************************************************************************************************
//  1. ֐
//		CMenuCommon::OnBnClickedButtonSlow
//----------------------------------------------------------------------------------------------------
//  2. @\
//		uᑬv{^NbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CMenuCommon::OnBnClickedButtonSlow()
{
	m_bSlowSpeed = TRUE;
	SendMessageParent(WM_USER_SLOW);
	EnableSpeedButton(TRUE);
}

//*****************************************************************************************************
//  1. ֐
//		CMenuCommon::OnBnClickedButtonNormal
//----------------------------------------------------------------------------------------------------
//  2. @\
//		uʏv{^NbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CMenuCommon::OnBnClickedButtonNormal()
{
	m_bSlowSpeed = FALSE;
	SendMessageParent(WM_USER_NORMAL);
	EnableSpeedButton(TRUE);
}

//*****************************************************************************************************
//  1. ֐
//		CMenuCommon::EnableSpeedButton
//----------------------------------------------------------------------------------------------------
//  2. @\
//		uꎞ~vuᑬvuʏv{^L
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		BOOL	bStart		[I] TRUE:Jn@FALSE:I
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CMenuCommon::EnableSpeedButton(BOOL bStart)
{
	if (bStart) {
		EnableButton(IDC_BUTTON_PAUSE, TRUE);
		EnableButton(IDC_BUTTON_SLOW, TRUE);
		EnableButton(IDC_BUTTON_NORMAL, m_bSlowSpeed);
	} else {
		EnableButton(IDC_BUTTON_PAUSE, FALSE);
		EnableButton(IDC_BUTTON_SLOW, FALSE);
		EnableButton(IDC_BUTTON_NORMAL, FALSE);
	}
}

//*****************************************************************************************************
//  1. ֐
//		CMenuCommon::EnableButton
//----------------------------------------------------------------------------------------------------
//  2. @\
//		{^NbNL
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		UINT	nID			[I] {^̃Rg[ID
//		BOOL	bEnable		[I] TRUE:L@FALSE:
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CMenuCommon::EnableButton(UINT nID, BOOL bEnable)
{
	CWnd *pWnd = GetDlgItem(nID);
	if (pWnd != NULL) {
		CMenuButton cButton;
		cButton.Attach(pWnd->m_hWnd);
		cButton.SetEnable(bEnable);
		cButton.Detach();
	}
}
